Index: branches/HTM-10.1-dev0/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/HTM-10.1-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 881)
+++ branches/HTM-10.1-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 882)
@@ -388,17 +388,9 @@
   ("VpsNumLayerSets",       m_vpsNumLayerSets    , 1                    , "Number of layer sets")    
   ("LayerIdsInSet_%d",      m_layerIdsInSets     , std::vector<Int>(1,0), MAX_VPS_OP_SETS_PLUS1 ,"LayerIds of Layer set")  
-#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
   ("DefaultTargetOutputLayerIdc"     , m_defaultTargetOutputLayerIdc     , 0, "Specifies output layers of layer sets, 0: output all layers, 1: output highest layer, 2: specified by LayerIdsInDefOutputLayerSet")
-#else
-  ("DefaultOneTargetOutputLayerFlag"  , m_defaultOneTargetOutputLayerIdc  , 0, "Output highest layer of layer sets by default")
-#endif
   ("OutputLayerSetIdx",     m_outputLayerSetIdx  , std::vector<Int>(0,0), "Indices of layer sets used as additional output layer sets")  
 
-#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
   ("LayerIdsInAddOutputLayerSet_%d", m_layerIdsInAddOutputLayerSet      , std::vector<Int>(0,0), MAX_VPS_ADD_OUTPUT_LAYER_SETS, "Indices in VPS of output layers in additional output layer set")  
   ("LayerIdsInDefOutputLayerSet_%d", m_layerIdsInDefOutputLayerSet      , std::vector<Int>(0,0), MAX_VPS_OP_SETS_PLUS1, "Indices in VPS of output layers in layer set")  
-#else
-  ("LayerIdsInAddOutputLayerSet_%d", m_layerIdsInAddOutputLayerSet      , std::vector<Int>(1,0), MAX_VPS_ADD_OUTPUT_LAYER_SETS, "LayerIds of additional output layers")  
-#endif
   ("ProfileLevelTierIdx",   m_profileLevelTierIdx, std::vector<Int>(1,0), "Indices to profile level tier")
   
@@ -611,15 +603,9 @@
 #if H_MV
 
-  // DBP Size
-#if !H_MV_HLS_7_FIX_SET_DPB_SIZE
-  ("SubLayerFlagInfoPresentFlag",  m_subLayerFlagInfoPresentFlag , false                                           , "SubLayerFlagInfoPresentFlag")
-#endif
   // VPS VUI
   ("VpsVuiPresentFlag"           , m_vpsVuiPresentFlag           , false                                           , "VpsVuiPresentFlag           ")
   ("CrossLayerPicTypeAlignedFlag", m_crossLayerPicTypeAlignedFlag, false                                           , "CrossLayerPicTypeAlignedFlag")  // Could actually be derived by the encoder
   ("CrossLayerIrapAlignedFlag"   , m_crossLayerIrapAlignedFlag   , false                                           , "CrossLayerIrapAlignedFlag   ")  // Could actually be derived by the encoder
-#if H_MV_HLS_7_MISC_P0068_21
   ("AllLayersIdrAlignedFlag"     , m_allLayersIdrAlignedFlag     , false                                           , "CrossLayerIrapAlignedFlag   ")  // Could actually be derived by the encoder
-#endif
   ("BitRatePresentVpsFlag"       , m_bitRatePresentVpsFlag       , false                                           , "BitRatePresentVpsFlag       ")
   ("PicRatePresentVpsFlag"       , m_picRatePresentVpsFlag       , false                                           , "PicRatePresentVpsFlag       ")
@@ -735,5 +721,4 @@
   ("SEISOPDescription",              m_SOPDescriptionSEIEnabled,              0, "Control generation of SOP description SEI messages")
   ("SEIScalableNesting",             m_scalableNestingSEIEnabled,              0, "Control generation of scalable nesting SEI messages")
-#if H_MV_HLS_7_SEI_P0204_26
   ("SubBitstreamPropSEIEnabled",              m_subBistreamPropSEIEnabled,    false                     ,"Enable signaling of sub-bitstream property SEI message")
   ("SEISubBitstreamNumAdditionalSubStreams",  m_sbPropNumAdditionalSubStreams,0, "Number of substreams for which additional information is signalled")
@@ -743,5 +728,4 @@
   ("SEISubBitstreamAvgBitRate",               m_sbPropAvgBitRate,             std::vector< Int  >(1,0)  ,"Specifies average bit rate of the i-th sub-bitstream")
   ("SEISubBitstreamMaxBitRate",               m_sbPropMaxBitRate,             std::vector< Int  >(1,0)  ,"Specifies maximum bit rate of the i-th sub-bitstream")
-#endif
 #if H_3D
   ("CameraParameterFile,cpf", m_pchCameraParameterFile,    (Char *) 0, "Camera Parameter File Name")
@@ -1430,5 +1414,4 @@
   }
 
-#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
   xConfirmPara( m_defaultTargetOutputLayerIdc < 0 || m_defaultTargetOutputLayerIdc > 2, "Default target output layer idc must greater than or equal to 0 and less than or equal to 2." );  
 
@@ -1461,7 +1444,5 @@
     }
   }
-#else
-  xConfirmPara( m_defaultOneTargetOutputLayerIdc < 0 || m_defaultOneTargetOutputLayerIdc > 1, "Default one target output layer idc must be equal to 0 or equal to 1" );
-#endif
+
   xConfirmPara( m_profileLevelTierIdx.size() < m_vpsNumLayerSets + m_outputLayerSetIdx.size(), "The number of Profile Level Tier indices must be equal to the number of layer set plus the number of output layer set indices" );
 
@@ -2245,6 +2226,4 @@
   }
   }
-#endif
-#if H_MV_HLS_7_SEI_P0204_26
   // Check input parameters for Sub-bitstream property SEI message
   if( m_subBistreamPropSEIEnabled )
Index: branches/HTM-10.1-dev0/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- branches/HTM-10.1-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 881)
+++ branches/HTM-10.1-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 882)
@@ -89,14 +89,8 @@
   Int                    m_vpsNumLayerSets;                   ///< Number of layer sets
   std::vector< std::vector<Int> > m_layerIdsInSets;           ///< LayerIds in vps of layer set 
-#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
   Int                    m_defaultTargetOutputLayerIdc;       ///< Specifies output layers of layer sets, 0: output all layers, 1: output highest layers, 2: specified by LayerIdsInDefOuputLayerSet
-#else
-  Int                    m_defaultOneTargetOutputLayerIdc;    ///< Output highest layer of layer sets by default when equal to 1
-#endif
   std::vector<Int>       m_outputLayerSetIdx;                 ///< Indices of layer sets used as additional output layer sets  
   std::vector< std::vector<Int> > m_layerIdsInAddOutputLayerSet; ///< LayerIds in vps of additional output layers
-#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
   std::vector< std::vector<Int> > m_layerIdsInDefOutputLayerSet; ///< Indices in vps of output layers in layer sets
-#endif
   std::vector<Int>       m_profileLevelTierIdx;               ///< Indices of of profile level tier
   
@@ -104,9 +98,4 @@
   std::vector< std::vector<Int> > m_directRefLayers;          ///< LayerIds of direct reference layers
   std::vector< std::vector<Int> > m_dependencyTypes;          ///< Dependency types of direct reference layers
-
-  // DBP Size
-#if !H_MV_HLS_7_FIX_SET_DPB_SIZE
-  Bool m_subLayerFlagInfoPresentFlag;
-#endif
 
   // VPS VUI
@@ -114,7 +103,5 @@
   Bool m_crossLayerPicTypeAlignedFlag;
   Bool m_crossLayerIrapAlignedFlag;
-#if H_MV_HLS_7_MISC_P0068_21
   Bool m_allLayersIdrAlignedFlag;
-#endif
   Bool m_bitRatePresentVpsFlag;
   Bool m_picRatePresentVpsFlag;
@@ -438,5 +425,5 @@
   Int       m_log2MaxMvLengthHorizontal;                      ///< Indicate the maximum absolute value of a decoded horizontal MV component in quarter-pel luma units
   Int       m_log2MaxMvLengthVertical;                        ///< Indicate the maximum absolute value of a decoded vertical MV component in quarter-pel luma units
-#if H_MV_HLS_7_SEI_P0204_26
+#if H_MV
   Bool              m_subBistreamPropSEIEnabled;
   Int               m_sbPropNumAdditionalSubStreams;
Index: branches/HTM-10.1-dev0/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/HTM-10.1-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 881)
+++ branches/HTM-10.1-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 882)
@@ -127,7 +127,5 @@
   xSetRepFormat            ( vps ); 
   xSetLayerSets            ( vps ); 
-#if H_MV_HLS_7_FIX_SET_DPB_SIZE
   xSetDpbSize              ( vps ); 
-#endif
   xSetVPSVUI               ( vps ); 
 #if H_3D
@@ -427,5 +425,5 @@
   m_cTEncTop.setSOPDescriptionSEIEnabled( m_SOPDescriptionSEIEnabled );
   m_cTEncTop.setScalableNestingSEIEnabled( m_scalableNestingSEIEnabled );
-#if H_MV_HLS_7_SEI_P0204_26
+#if H_MV
   m_cTEncTop.setSubBitstreamPropSEIEnabled( m_subBistreamPropSEIEnabled );
   if( m_subBistreamPropSEIEnabled )
@@ -1504,5 +1502,4 @@
 }
 
-#if H_MV_HLS_7_FIX_SET_DPB_SIZE
 Void TAppEncTop::xSetDpbSize                ( TComVPS& vps )
 {
@@ -1518,18 +1515,9 @@
     Bool subLayerFlagInfoPresentFlag = false; 
 
-#if H_MV_HLS_7_HRD_P0156_7
     for( Int j = 0; j  <=  vps.getMaxSubLayersInLayerSetMinus1( i ); j++ )
-#else
-    for( Int j = 0; j  <=  vps.getMaxTLayers() - 1 ; j++ )
-#endif
     {   
       Bool subLayerDpbInfoPresentFlag = false; 
-#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
       assert( vps.getNumSubDpbs( vps.getLayerSetIdxForOutputLayerSet( i ) ) == targetDecLayerIdList.size() ); 
       for( Int k = 0; k < vps.getNumSubDpbs( vps.getLayerSetIdxForOutputLayerSet( i )); k++ )   
-#else
-      assert( vps.getNumSubDpbs( vps.getOutputLayerSetIdxMinus1( i ) + 1 ) == targetDecLayerIdList.size() ); 
-      for( Int k = 0; k < vps.getNumSubDpbs( vps.getOutputLayerSetIdxMinus1( i ) + 1 ); k++ )   
-#endif
       {
         Int layerIdInVps = vps.getLayerIdInVps( targetDecLayerIdList[k] );           
@@ -1574,60 +1562,5 @@
   }  
 }
-#else
-Void TAppEncTop::xSetDpbSize                ( TComVPS& vps )
-{
-  // These settings need to be verified
-
-  TComDpbSize* dpbSize = vps.getDpbSize(); 
-
-  assert ( dpbSize != 0 ); 
-
-  for( Int i = 1; i < vps.getNumOutputLayerSets(); i++ )
-  {  
-    std::vector<Int> targetDecLayerIdList = vps.getTargetDecLayerIdList( i ); 
-    dpbSize->setSubLayerFlagInfoPresentFlag( i, m_subLayerFlagInfoPresentFlag );
-    if ( dpbSize->getSubLayerFlagInfoPresentFlag( i ) )
-    {
-      for( Int j = 0; j  <=  vps.getMaxTLayers() - 1 ; j++ )
-      {   
-        Int maxNumReorderPics  = MIN_INT; 
-        Int maxDecPicBuffering = MIN_INT; 
-        Int maxLatencyIncrease = MIN_INT; 
-
-        Int prevMaxNumReorderPics  = MIN_INT; 
-        Int prevMaxDecPicBuffering = MIN_INT; 
-        Int prevMaxLatencyIncrease = MIN_INT; 
-
-        assert( vps.getNumSubDpbs( vps.getOutputLayerSetIdxMinus1( i ) + 1 ) == targetDecLayerIdList.size() ); 
-        for( Int k = 0; k < vps.getNumSubDpbs( vps.getOutputLayerSetIdxMinus1( i ) + 1 ); k++ )   
-        {
-          Int layerIdInVps = vps.getLayerIdInVps( targetDecLayerIdList[k] );           
-          dpbSize->setMaxVpsDecPicBufferingMinus1( i, k, j, m_maxDecPicBufferingMvc[ layerIdInVps ][ j ] - 1 );
-        }        
-
-        for ( Int idx = 0; idx < targetDecLayerIdList.size(); idx++ )
-        {
-          Int layerIdInVps = vps.getLayerIdInVps( targetDecLayerIdList[ idx ] ); 
-          maxNumReorderPics = std::max( maxNumReorderPics, m_numReorderPicsMvc[ layerIdInVps ][ j ] ); 
-        }
-        assert( maxNumReorderPics != MIN_INT ); 
-        dpbSize->setMaxVpsNumReorderPics( i, j, maxNumReorderPics );
-
-        // To Be Done !
-        // dpbSize->setMaxVpsLatencyIncreasePlus1( i, j, uiCode );
-
-        if( j > 0 )  
-        {
-          dpbSize->setSubLayerDpbInfoPresentFlag( i, j, prevMaxDecPicBuffering == maxDecPicBuffering && prevMaxLatencyIncrease == maxLatencyIncrease && prevMaxNumReorderPics == maxNumReorderPics );
-        }        
-
-        prevMaxNumReorderPics   = maxNumReorderPics; 
-        prevMaxDecPicBuffering  = maxDecPicBuffering; 
-        prevMaxLatencyIncrease  = maxLatencyIncrease; 
-      }  
-    }  
-  }  
-}
-#endif
+
 
 Void TAppEncTop::xSetLayerSets( TComVPS& vps )
@@ -1635,7 +1568,4 @@
   // Layer sets
   vps.setVpsNumLayerSetsMinus1   ( m_vpsNumLayerSets - 1 ); 
-#if !H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
-  vps.setVpsNumberLayerSetsMinus1( vps.getVpsNumLayerSetsMinus1() ); 
-#endif
     
   for (Int lsIdx = 0; lsIdx < m_vpsNumLayerSets; lsIdx++ )
@@ -1654,15 +1584,8 @@
   Int numAddOuputLayerSets = (Int) m_outputLayerSetIdx.size(); 
   // Additional output layer sets + profileLevelTierIdx
-#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
   vps.setDefaultTargetOutputLayerIdc      ( m_defaultTargetOutputLayerIdc );   
   vps.setNumAddOutputLayerSets            ( numAddOuputLayerSets          ); 
   vps.initTargetLayerIdLists(); 
-#else
-  vps.setDefaultOneTargetOutputLayerIdc   ( m_defaultOneTargetOutputLayerIdc ); 
-  vps.setMoreOutputLayerSetsThanDefaultFlag( numAddOuputLayerSets       != 0 );   
-  vps.setNumAddOutputLayerSetsMinus1       ( numAddOuputLayerSets - 1        ); 
-#endif
-
-#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
+
   for (Int olsIdx = 0; olsIdx < m_vpsNumLayerSets + numAddOuputLayerSets; olsIdx++)
   {
@@ -1714,43 +1637,5 @@
     vps.setAltOutputLayerFlag( olsIdx , false);     
   }
-#else
-  for (Int lsIdx = 0; lsIdx < m_vpsNumLayerSets; lsIdx++)
-  {
-    if ( lsIdx > 0 ) 
-    {
-      vps.setProfileLevelTierIdx( lsIdx, m_profileLevelTierIdx[ lsIdx ] ); 
-    }  
-
-    vps.setOutputLayerSetIdxMinus1( lsIdx, lsIdx - 1 ); 
-
-    for (Int i = 0; i < m_layerIdsInSets[ lsIdx ].size(); i++ )
-    { 
-      vps.setOutputLayerFlag( lsIdx, i, vps.inferOutputLayerFlag( lsIdx, i ));       
-    }
-  }
-
-  for (Int addOutLs = 0; addOutLs < numAddOuputLayerSets; addOutLs++ )
-  {
-    vps.setProfileLevelTierIdx( m_vpsNumLayerSets + addOutLs, m_profileLevelTierIdx[ addOutLs ] ); 
-
-    Int refLayerSetIdx = m_outputLayerSetIdx[ addOutLs ];     
-    vps.setOutputLayerSetIdxMinus1( m_vpsNumLayerSets + addOutLs, refLayerSetIdx - 1 ); 
-
-    for (Int i = 0; i < m_layerIdsInSets[ refLayerSetIdx].size(); i++ )
-    {
-      Bool outputLayerFlag = false; 
-      for (Int j = 0; j < m_layerIdsInAddOutputLayerSet[ addOutLs ].size(); j++ )
-      {
-        if (  m_layerIdsInAddOutputLayerSet[addOutLs][ j ] == m_layerIdsInSets[ refLayerSetIdx][ i ] )
-        {
-          outputLayerFlag = true; 
-          break; 
-        }
-      }
-      vps.setOutputLayerFlag( m_vpsNumLayerSets + addOutLs, i, outputLayerFlag );       
-    }
-  }
-  vps.deriveTargetLayerIdLists(); 
-#endif
+
 }
 
@@ -1759,17 +1644,9 @@
   vps.setVpsVuiPresentFlag( m_vpsVuiPresentFlag ); 
 
-#if H_MV_HLS_7_FIX_INFER_CROSS_LAYER_IRAP_ALIGNED_FLAG
   TComVPSVUI* pcVPSVUI = vps.getVPSVUI(  ); 
   assert( pcVPSVUI ); 
-#endif
 
   if ( m_vpsVuiPresentFlag )
   {
-#if !H_MV_HLS_7_FIX_INFER_CROSS_LAYER_IRAP_ALIGNED_FLAG
-    TComVPSVUI* pcVPSVUI = vps.getVPSVUI(  ); 
-
-    assert( pcVPSVUI ); 
-#endif
-
     // All this stuff could actually be derived by the encoder, 
     // however preliminary setting it from input parameters
@@ -1777,7 +1654,5 @@
     pcVPSVUI->setCrossLayerPicTypeAlignedFlag( m_crossLayerPicTypeAlignedFlag );
     pcVPSVUI->setCrossLayerIrapAlignedFlag   ( m_crossLayerIrapAlignedFlag    );
-#if H_MV_HLS_7_MISC_P0068_21
     pcVPSVUI->setAllLayersIdrAlignedFlag     ( m_allLayersIdrAlignedFlag      );
-#endif
     pcVPSVUI->setBitRatePresentVpsFlag( m_bitRatePresentVpsFlag );
     pcVPSVUI->setPicRatePresentVpsFlag( m_picRatePresentVpsFlag );
@@ -1785,9 +1660,5 @@
     if( pcVPSVUI->getBitRatePresentVpsFlag( )  ||  pcVPSVUI->getPicRatePresentVpsFlag( ) )
     {
-#if H_MV_HLS_7_OUTPUT_LAYERS_5_10_22_27
       for( Int i = 0; i  <=  vps.getVpsNumLayerSetsMinus1(); i++ )
-#else
-      for( Int i = 0; i  <=  vps.getVpsNumberLayerSetsMinus1(); i++ )
-#endif
       {
         for( Int j = 0; j  <=  vps.getMaxTLayers(); j++ ) 
@@ -1907,10 +1778,8 @@
     pcVPSVUI->setVpsVuiBspHrdPresentFlag( false ); // TBD
   }
-#if H_MV_HLS_7_FIX_INFER_CROSS_LAYER_IRAP_ALIGNED_FLAG
   else
   {
     pcVPSVUI->setCrossLayerIrapAlignedFlag   ( false   );
   }
-#endif
 }
 #endif