Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-2x.cfg	(revision 876)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-2x.cfg	(revision 911)
@@ -4,5 +4,5 @@
 
 #======== File I/O ===============
-InputFile0                    : BQTerrace_960x540_60_zerophase_0.9pi.yuv
+InputFile0                    : BQTerrace_960x544_60_zerophase_0.9pi.yuv
 FrameRate0                    : 60          # Frame Rate per second
 InputBitDepth0                : 8           # Input bitdepth for layer 0
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-SNR.cfg	(revision 876)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/BQTerrace-SNR.cfg	(revision 911)
@@ -4,5 +4,5 @@
 
 #======== File I/O ===============
-InputFile0                    : BQTerrace_1920x1080_60.yuv
+InputFile0                    : BQTerrace_1920x1088_60.yuv
 FrameRate0                    : 60          # Frame Rate per second
 InputBitDepth0                : 8           # Input bitdepth for layer 0
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-2x.cfg	(revision 876)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-2x.cfg	(revision 911)
@@ -4,5 +4,5 @@
 
 #======== File I/O ===============
-InputFile0                    : BasketballDrive_960x540_50_zerophase_0.9pi.yuv
+InputFile0                    : BasketballDrive_960x544_50_zerophase_0.9pi.yuv
 FrameRate0                    : 50          # Frame Rate per second
 InputBitDepth0                : 8           # Input bitdepth for layer 0
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-SNR.cfg	(revision 876)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/BasketballDrive-SNR.cfg	(revision 911)
@@ -4,5 +4,5 @@
 
 #======== File I/O ===============
-InputFile0                    : BasketballDrive_1920x1080_50.yuv
+InputFile0                    : BasketballDrive_1920x1088_50.yuv
 FrameRate0                    : 50          # Frame Rate per second
 InputBitDepth0                : 8           # Input bitdepth for layer 0
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-2x.cfg	(revision 876)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-2x.cfg	(revision 911)
@@ -4,5 +4,5 @@
 
 #======== File I/O ===============
-InputFile0                    : Cactus_960x540_50_zerophase_0.9pi.yuv
+InputFile0                    : Cactus_960x544_50_zerophase_0.9pi.yuv
 FrameRate0                    : 50          # Frame Rate per second
 InputBitDepth0                : 8           # Input bitdepth for layer 0
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-SNR.cfg	(revision 876)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Cactus-SNR.cfg	(revision 911)
@@ -4,5 +4,5 @@
 
 #======== File I/O ===============
-InputFile0                    : Cactus_1920x1080_50.yuv
+InputFile0                    : Cactus_1920x1088_50.yuv
 FrameRate0                    : 50          # Frame Rate per second
 InputBitDepth0                : 8           # Input bitdepth for layer 0
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-2x.cfg	(revision 876)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-2x.cfg	(revision 911)
@@ -4,5 +4,5 @@
 
 #======== File I/O ===============
-InputFile0                    : Kimono1_960x540_24_zerophase_0.9pi.yuv
+InputFile0                    : O:/Kimono1_960x544_24_zerophase_0.9pi.yuv
 FrameRate0                    : 24          # Frame Rate per second
 InputBitDepth0                : 8           # Input bitdepth for layer 0
@@ -14,5 +14,5 @@
 QP0                           : 22
 
-InputFile1                    : Kimono1_1920x1080_24.yuv
+InputFile1                    : O:/Kimono1_1920x1080_24.yuv
 FrameRate1                    : 24          # Frame Rate per second
 InputBitDepth1                : 8           # Input bitdepth for layer 1
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-SNR.cfg	(revision 876)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/Kimono-SNR.cfg	(revision 911)
@@ -4,5 +4,5 @@
 
 #======== File I/O ===============
-InputFile0                    : Kimono1_1920x1080_24.yuv
+InputFile0                    : Kimono1_1920x1088_24.yuv
 FrameRate0                    : 24          # Frame Rate per second
 InputBitDepth0                : 8           # Input bitdepth for layer 0
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-2x.cfg	(revision 876)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-2x.cfg	(revision 911)
@@ -4,5 +4,5 @@
 
 #======== File I/O ===============
-InputFile0                    : ParkScene_960x540_24_zerophase_0.9pi.yuv
+InputFile0                    : ParkScene_960x544_24_zerophase_0.9pi.yuv
 FrameRate0                    : 24          # Frame Rate per second
 InputBitDepth0                : 8           # Input bitdepth for layer 0
Index: branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-SNR.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-SNR.cfg	(revision 876)
+++ branches/SHM-dev/cfg/per-sequence-svc-avcbase/ParkScene-SNR.cfg	(revision 911)
@@ -4,5 +4,5 @@
 
 #======== File I/O ===============
-InputFile0                    : ParkScene_1920x1080_24.yuv
+InputFile0                    : ParkScene_1920x1088_24.yuv
 FrameRate0                    : 24          # Frame Rate per second
 InputBitDepth0                : 8           # Input bitdepth for layer 0